%include "inc/common/macros"

SECTION .text
	global _start
_start:
	mov eax, 07dh              ;sys mprotect (pinched from IsForth :-)
	mov ebx, 08048000h
	mov ecx, 00100000h
	mov edx, 7
	int 080h                   ;make the entire program space rwx

	lea esi, [esp-0x200]	;Initialize data stack

MAIN:   upsh startup            ;Load startup code (startup.f)
        upsh startup.1 - startup
        call eval
	call interpret
;---------------------------------------------------------------------
%include "drivers/linux/all"
section .bss
tib  resb   200h
d0   resb 10000h
h0   resb 80000h
section .text
;---------------------------------------------------------------------
%include "forth.asm"
;---------------------------------------------------------------------
section .data
startup: incbin "boot/common.f"
         incbin "boot/edit.f"
         incbin "boot/linux/drivers.f"
	 incbin "boot/welcome.f"
.1
END
